<template>
  <div class="fade-in">
    <div v-show="!manufacturer">
      <v-retry-button v-if="error === ManufacturerError.CANNOT_LOAD_MANUFACTURER" @click="loadManufacturer"/>
      <v-button
          v-if="!error"
          :type="ButtonType.SUCCESS"
          :in-progress="inProgress"
          @click="createManufacturer"
      >
        Become manufacturer
      </v-button>
    </div>
    <div v-if="manufacturer">
      <h2>Your manufacturer id:</h2>
      <input
          type="text"
          :value="manufacturer.manufacturerId"
          readonly
          title="Copied"
          v-tippy="{ placement: 'bottom', arrow: true, trigger: 'click', theme: 'tomato' }"
          id="input-manufacturer-id"
          @click.prevent="copy(manufacturer.manufacturerId)"
      />
    </div>
  </div>
</template>

<script>
  import { createNamespacedHelpers } from 'vuex'
  import copy from 'copy-to-clipboard'

  import VButton from 'zeus-common/src/component/button/VButton'
  import VRetryButton from 'zeus-common/src/component/button/VRetryButton'
  import { ButtonType } from 'zeus-common'
  import { ManufacturerError } from './service'

  const { mapState } = createNamespacedHelpers('manufacturer')

  export default {
    name: 'ManufacturerPage',
    components: { VRetryButton, VButton },
    data: () => ({
      ButtonType: ButtonType,
      ManufacturerError: ManufacturerError
    }),
    computed: {
      ...mapState([ 'inProgress' , 'error', 'manufacturer' ])
    },
    mounted() {
      this.loadManufacturer()
    },
    methods: {
      loadManufacturer() {
        if (this.error) {
          this.$store.commit('manufacturer/resetError')
        }
        this.$store.dispatch('manufacturer/loadManufacturer')
      },
      createManufacturer() {
        if (this.error) {
          this.$store.commit('manufacturer/resetError')
        }
        this.$store.dispatch('manufacturer/becomeManufacturer')
      },
      copy: copy
    }
  }
</script>

<style scoped>
  #input-manufacturer-id {
    cursor: pointer;
  }
</style>